byte sem = 3;
byte critical = 0; /* ghost variable
                      for verification only */

active [4] proctype P() {
  do ::
        printf("P%d non-critical actions\n", _pid);
        atomic { /* "wait(sem)" */
          sem > 0;
          sem-- 
        }
        /* begin critical section */
        critical++;
	printf("P%d uses shared resourses\n", _pid);
        assert (critical <= 3);
        critical--;
        /* end critical section */
        sem++    /* "signal(sem)" */
  od
}

